#!/bin/sh
#
# Costruisce una pagina HTML dinamica con le informazioni
# sullo stato del server
#
# Oltre alle consuete utility (head, cut, cat, ecc.) necessita di:
#
# - lm_sensors installato e funzionanate con l'interfaccia /proc;
# - GNU bc (per fare la conversione lettura A/D --> valore)
# - smartmonitor con opportuna interfaccia installato e funzionante
#
# (C) I1EPJ 2003-2004
#
export LANG=it_IT
export LANGUAGE=it_IT
export MYURL=http://ir1bi.1.it.ampr.org/img
#
# Read FIFOs to remove old values (may be VERY old!)
# head is used here to stop reading FIFO at first newline
# 
head -n 1 -q /var/spool/smartmonitor/temp  > /dev/null
head -n 1 -q /var/spool/smartmonitor/valim > /dev/null
head -n 1 -q /var/spool/smartmonitor/din1  > /dev/null
head -n 1 -q /var/spool/smartmonitor/din2  > /dev/null
head -n 1 -q /var/spool/smartmonitor/din3  > /dev/null
head -n 1 -q /var/spool/smartmonitor/din4  > /dev/null
#
# Get new values from FIFOs
#
TEMP=`head -n 1 -q /var/spool/smartmonitor/temp`
VALIM=`head -n 1 -q /var/spool/smartmonitor/valim`
SW1=`head -n 1 -q /var/spool/smartmonitor/din1`
SW2=`head -n 1 -q /var/spool/smartmonitor/din2`
SW3=`head -n 1 -q /var/spool/smartmonitor/din3`
SW4=`head -n 1 -q /var/spool/smartmonitor/din4`

# 
# Data from lm_sensors 
# 
CPUTemp=`cat /proc/sys/dev/sensors/w83781d-isa-0290/temp2 | cut -f3 -d" "`
SYSTemp=`cat /proc/sys/dev/sensors/w83781d-isa-0290/temp1 | cut -f3 -d" "`
VCore1=`cat /proc/sys/dev/sensors/w83781d-isa-0290/in0 | cut -f3 -d" "`
VCore2=`cat /proc/sys/dev/sensors/w83781d-isa-0290/in1 | cut -f3 -d" "`
P33V=`cat /proc/sys/dev/sensors/w83781d-isa-0290/in2 | cut -f3 -d" "`

P5VR=`cat /proc/sys/dev/sensors/w83781d-isa-0290/in3 | cut -f3 -d" "`
P12VR=`cat /proc/sys/dev/sensors/w83781d-isa-0290/in4 | cut -f3 -d" "`
M12VR=`cat /proc/sys/dev/sensors/w83781d-isa-0290/in5 | cut -f3 -d" "`
M5VR=`cat /proc/sys/dev/sensors/w83781d-isa-0290/in6 | cut -f3 -d" "`

P5V=`echo "scale=2; (6.8/10+1)*$P5VR" | bc`
P12V=`echo "scale=2; (28/10+1)*$P12VR" | bc`
M12V=`echo "scale=2; -(210/60.4)*$M12VR" | bc`
M5V=`echo "scale=2; -(90.9/60.4)*$M12VR" | bc`
CPUFan=`cat /proc/sys/dev/sensors/w83781d-isa-0290/fan1 | cut -f2 -d" "`
SYSFan=`cat /proc/sys/dev/sensors/w83781d-isa-0290/fan3 | cut -f2 -d" "`
#
# Data from APC UPS
#
UPSSTATUS=`cat /var/log/apcupsd.status | grep STATUS | cut -f5 -d" "`
#
# Uptime
#
UPTIME=`cat /proc/uptime | cut -f1 -d" " | cut -f1 -d"."`
UP_SEC=`echo $UPTIME % 60 | bc`
UPTIME=$(($UPTIME / 60))
UP_MIN=`echo $UPTIME % 60 | bc`
UPTIME=$(($UPTIME / 60))
UP_HRS=`echo $UPTIME % 24 | bc`
UP_DAY=$(($UPTIME / 24))

cat << EOF
Content-type: text/html

<html>
<head>
  <title>Stato del server</title>
  <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
  <meta name="GENERATOR" content="status-cgi">
</head>
<body background="$MYURL/sfondo04.jpg">
<P ALIGN=CENTER><FONT COLOR="#0e9cf1"><FONT SIZE=1><B><IMG SRC="$MYURL/Gpcm-lgo.jpg" NAME="Immagine1" ALIGN=BOTTOM WIDTH=800 HEIGHT=105 BORDER=0></B></FONT></FONT></P>
<CENTER>
	<TABLE WIDTH="100%" BORDER=0 CELLPADDING=0 CELLSPACING=0>
		<TR>
			<TD WIDTH="100%" BGCOLOR="#008000">
				<P ALIGN=RIGHT><FONT SIZE=5 STYLE="font-size: 24pt" COLOR="#ffffff"><B>Stato del server</B></FONT></P>
			</TD>
		</TR>
	</TABLE>
</CENTER>

<TABLE WIDTH="100%" BORDER=0 CELLPADDING=0 CELLSPACING=0>
    <TR>
        <TD>
    	    <HR>
	</TD>
    </TR>
</TABLE>
<TABLE WIDTH="100%" BORDER=0 CELLPADDING=0 CELLSPACING=0>
    <TR>
        <TD WIDTH="25%">
            <img src="$MYURL/FotoArmadio.jpg" ALT="L'armadio contenente il server al 26/9/2004" width=330 height=768 align="left" border=0>
        </TD>
	<TD WIDTH="65%">
	    <TABLE WIDTH="100%" BORDER=0 CELLPADDING=0 CELLSPACING=0>
    		<TR>
		    <TD WIDTH="100%">
                	<HR>
		    </TD>
    		</TR>
	    </TABLE>
	    <BR>
	    <TABLE WIDTH="100%" BORDER=0 CELLPADDING=0 CELLSPACING=0>
    		<TR>
		    <TD WIDTH="35%">
                        <FONT SIZE=5 STYLE="font-size: 22pt"><font color="#ffffff">Data/Ora GMT</FONT></FONT>
		    </TD>
		    <TD WIDTH="65%">
                        <FONT SIZE=5 STYLE="font-size: 22pt"><font color="#00ff00">
EOF
#
# Data/Ora
#
date +"%_d %B %Y %k:%M:%S"
#
# --------
#
cat << EOF
			</FONT></FONT>
		    </TD>
    		</TR>
	    </TABLE>
	    <BR>
	    <TABLE WIDTH="100%" BORDER=0 CELLPADDING=0 CELLSPACING=0>
    		<TR>
		    <TD WIDTH="100%">
                        <HR>
		    </TD>
    		</TR>
	    </TABLE>
	    <BR>
	    <TABLE WIDTH="100%" BORDER=0 CELLPADDING=0 CELLSPACING=0>
		<TR>
    		    <TD WIDTH="35%">
        		<FONT SIZE=5 STYLE="font-size: 22pt"><font color="#ffffff">Uptime:
			</font></FONT>
		    </TD>
    		    <TD WIDTH="65%">
        		<FONT SIZE=5 STYLE="font-size: 22pt"><font color="#00ff00">
			$UP_DAY giorni, $UP_HRS ore, $UP_MIN minuti
			</FONT></FONT>
		    </TD>
		</TR>
	    </TABLE>
	    <BR>
	    <TABLE WIDTH="100%" BORDER=0 CELLPADDING=0 CELLSPACING=0>
    		<TR>
		    <TD WIDTH="100%">
                        <HR>
		    </TD>
    		</TR>
	    </TABLE>
	    <BR>
	    <TABLE WIDTH="100%" BORDER=0 CELLPADDING=0 CELLSPACING=0>
    		<TR>
		    <TD WIDTH="35%">
                        <FONT SIZE=5 STYLE="font-size: 22pt" color="#ffffff">V<SUB>CC</SUB></FONT>
            	    </TD>
		    <TD WIDTH="65%">
                        <FONT SIZE=5 STYLE="font-size: 22pt" color="#00ff00">+$VALIM &nbsp;V
			</FONT>
		    </TD>
    		</TR>
	    </TABLE>
	    <BR>
	    <TABLE WIDTH="100%" BORDER=0 CELLPADDING=0 CELLSPACING=0>
    		<TR>
		    <TD WIDTH="100%">
                        <HR>
		    </TD>
    		</TR>
	    </TABLE>
	    <BR>
	    <TABLE WIDTH="100%" BORDER=0 CELLPADDING=0 CELLSPACING=0>
    		<TR>
		    <TD WIDTH="35%">
                        <FONT SIZE=5 STYLE="font-size: 22pt" color="#ffffff">Temperatura</FONT>
            	    </TD>
		    <TD WIDTH="65%">
                        <FONT SIZE=5 STYLE="font-size: 22pt" color="#00ff00">+
EOF

echo $TEMP

cat << EOF
			&nbsp;&deg;C
			</FONT>
		    </TD>
    		</TR>
	    </TABLE>
	    <BR>
	    <TABLE WIDTH="100%" BORDER=0 CELLPADDING=0 CELLSPACING=0>
    		<TR>
		    <TD WIDTH="100%">
                        <HR>
		    </TD>
    		</TR>
	    </TABLE>
	    <BR>
	    <TABLE WIDTH="100%" BORDER=0 CELLPADDING=0 CELLSPACING=0>
    		<TR>
		    <TD WIDTH="35%">
                        <FONT SIZE=5 STYLE="font-size: 22pt" color="#ffffff">Porta</font>
            	    </TD>
		    <TD WIDTH="32.5%">
			<FONT SIZE=5 STYLE="font-size: 22pt" color="#00ff00">
EOF
#
# Porta I
#
if [ "$SW1" = "0" ]; then
                	echo "<img src=\"$MYURL/checkgreen.png\" ALT=\"X\" width=32 height=32 border=0>"
else
                	echo "<img src=\"$MYURL/checkvuoto.png\" ALT=\"&nbsp;\" width=32 height=32 border=0>"
fi
#
# -------
#
cat << EOF
			&nbsp;Chiusa
			</FONT>
		    </TD>
		    <TD WIDTH="32.5%">
                        <FONT SIZE=5 STYLE="font-size: 22pt" color="#ff0000">
EOF
#
# Porta II
#
if [ "$SW1" = "0" ]; then
			echo "<img src=\"$MYURL/checkvuoto.png\" ALT=\"&nbsp;\" width=32 height=32 border=0>"
else
			echo "<img src=\"$MYURL/checkred.png\" ALT=\"X\" width=32 height=32 border=0>"
fi
#
# --------
#
cat << EOF
			&nbsp;Aperta
			</FONT>
            	    </TD>
    		</TR>
    		<TR>
		    <TD WIDTH="35%">
                        <FONT SIZE=5 STYLE="font-size: 22pt" color="#ffffff">Ventola</FONT>
            	    </TD>
		    <TD WIDTH="32.5%">
                        <FONT SIZE=5 STYLE="font-size: 22pt" color="#00ff00">
EOF
#
# Ventola I
#
if [ "$SW2" = "1" ]; then
			echo "<img src=\"$MYURL/checkgreen.png\" ALT=\"X\">"
else
			echo "<img src=\"$MYURL/checkvuoto.png\" ALT=\"&nbsp;\">"
fi
#
# ---------
#
cat << EOF
			&nbsp;Spenta
			</FONT>
		    </TD>
		    <TD WIDTH="32.5%">
                        <FONT SIZE=5 STYLE="font-size: 22pt" color="#ff0000">
EOF
#
# Ventola II
#
if [ "$SW2" = "1" ]; then
			echo "<img src=\"$MYURL/checkvuoto.png\" ALT=\"&nbsp;\">"
else
			echo "<img src=\"$MYURL/checkred.png\" ALT=\"X\">"
fi
#
# ----------
#
cat << EOF
			&nbsp;Accesa
			</FONT>
            	    </TD>
    		</TR>
    		<TR>
		    <TD WIDTH="35%">
                        <FONT SIZE=5 STYLE="font-size: 22pt" color="#ffffff">Alimentazione</FONT>
            	    </TD>
		    <TD WIDTH="32.5%">
                        <FONT SIZE=5 STYLE="font-size: 22pt" color="#00ff00">
EOF
#
# Rete I
#
if [ "$UPSSTATUS" = "ONLINE" ]; then
			echo "<img src=\"$MYURL/checkgreen.png\" ALT=\"X\">"
else
			echo "<img src=\"$MYURL/checkvuoto.png\" ALT=\"&nbsp;\">"
fi
#
# ----
#
cat << EOF
			&nbsp;Rete</FONT>
		    </TD>
		    <TD WIDTH="32.5%">
                        <FONT SIZE=5 STYLE="font-size: 22pt" color="#ff0000">
EOF
#
# Rete II
#
if [ "$UPSSTATUS" = "ONLINE" ]; then
			echo "<img src=\"$MYURL/checkvuoto.png\" ALT=\"&nbsp;\">"
else
			echo "<img src=\"$MYURL/checkred.png\" ALT=\"X\">"
fi
#
# ------
#
cat << EOF
			&nbsp;UPS
			</FONT>
            	    </TD>
    		</TR>
	    </TABLE>
	    <BR>
EOF

#
# Stato PC
#
cat << EOF
	    <TABLE WIDTH="100%" BORDER=0 CELLPADDING=0 CELLSPACING=0>
		<TR>
		    <TD WIDTH="100%">
            		<HR>
		    </TD>
		</TR>
	    </TABLE>
	    <BR>
	    <TABLE WIDTH="100%" BORDER=0 CELLPADDING=0 CELLSPACING=0>
		<TR>
		    <TD WIDTH="35%">
                        <FONT SIZE=5 STYLE="font-size: 20pt"><font color="#ffffff">Stato del PC</font></FONT>
		    </TD>
		    <TD WIDTH="32.5%">
                        <FONT SIZE=5 STYLE="font-size: 20pt"><font color="#00ff00">
			T<SUB>CPU</SUB>=$CPUTemp &deg;C 
			</FONT></FONT>
		    </TD>
		    <TD WIDTH="32.5%">
                        <FONT SIZE=5 STYLE="font-size: 20pt"><font color="#00ff00">
			T<SUB>SYS</SUB>=$SYSTemp &deg;C 
			</FONT></FONT>
		    </TD>
		</TR>
    		<TR>
		    <TD WIDTH="35%">
		    </TD>
		    <TD WIDTH="32.5%">
                        <FONT SIZE=5 STYLE="font-size: 20pt"><font color="#00ff00">
			Fan<SUB>CPU</SUB>=$CPUFan rpm 
			</FONT></FONT>
		    </TD>
		    <TD WIDTH="32.5%">
                        <FONT SIZE=5 STYLE="font-size: 20pt"><font color="#00ff00">
			Fan<SUB>SYS</SUB>=$SYSFan rpm 
			</FONT></FONT>
		    </TD>
		</TR>
    		<TR>
		    <TD WIDTH="35%">
		    </TD>
		    <TD WIDTH="32.5%">
                        <FONT SIZE=5 STYLE="font-size: 20pt"><font color="#00ff00">
			V<SUB>CORE1</SUB>=$VCore1 V 
			</FONT></FONT>
		    </TD>
		    <TD WIDTH="32.5%">
                        <FONT SIZE=5 STYLE="font-size: 20pt"><font color="#00ff00">
			V<SUB>TT</SUB>=$VCore2 V 
			</FONT></FONT>
		    </TD>
		</TR>
    		<TR>
		    <TD WIDTH="35%">
		    </TD>
		    <TD WIDTH="32.5%">
                        <FONT SIZE=5 STYLE="font-size: 20pt"><font color="#00ff00">
			+3.3V=$P33V V 
			</FONT></FONT>
		    </TD>
		    <TD WIDTH="32.5%">
            		<FONT SIZE=5 STYLE="font-size: 20pt"><font color="#00ff00">
			+5V=$P5V V 
			</FONT></FONT>
		    </TD>
		</TR>
    		<TR>
		    <TD WIDTH="35%">
		    </TD>
		    <TD WIDTH="32.5%">
                        <FONT SIZE=5 STYLE="font-size: 20pt"><font color="#00ff00">
			+12V=$P12V V 
			</FONT></FONT>
		    </TD>
		    <TD WIDTH="32.5%">
                        <FONT SIZE=5 STYLE="font-size: 20pt"><font color="#00ff00">
			-5V=$M5V V 
			</FONT></FONT>
		    </TD>
		</TR>
    		<TR>
		    <TD WIDTH="35%">
		    </TD>
		    <TD WIDTH="32.5%">
                	<FONT SIZE=5 STYLE="font-size: 20pt"><font color="#00ff00">
			-12V=$M12V V 
			</FONT></FONT>
		    </TD>
		    <TD WIDTH="32.5%">
		    </TD>
		</TR>
	    </TABLE>
	    <TABLE WIDTH="100%" BORDER=0 CELLPADDING=0 CELLSPACING=0>
		<TR>
		    <TD WIDTH="100%">
                        <HR>
		    </TD>
		</TR>
	    </TABLE>
	</TD>
    </TR>
</TABLE>
EOF
#
# --------
#
cat << EOF
<TABLE WIDTH="100%" BORDER=0 CELLPADDING=0 CELLSPACING=0>
	<TR>
		<TD WIDTH="100%">
                        <HR>
		</TD>
	</TR>
</TABLE>
<TABLE WIDTH="100%" BORDER=0 CELLPADDING=0 CELLSPACING=0>
	<TR>
		<TD WIDTH="100%">
			<P ALIGN=RIGHT>
			<font size=1 color="#808080">Pagina generata da status.cgi by I1EPJ</font>
			</P>
		</TD>
        </TR>
</TABLE>
</body>
</html>
EOF
